classdef MatlabFTCL5040Sensor < handle;

    properties
        jobject;
        callbacks = {};
        port;
        baudrate;
    end
    
    
    methods
        
        function obj = MatlabFTCL5040Sensor(port, baudrate)
            
           
             
            
            obj.port = port;
            obj.baudrate = baudrate;
            
            
        end
        
        function open(obj)
            import de.IAS.FTCL5040Sensor;
            
            if(ishandle(obj.jobject))
                set(obj.jobject, 'PropertyChangeCallback',{});
                obj.jobject.close();
                obj.jobject.delete();
            end
            
            obj.jobject = handle(FTCL5040Sensor(obj.port, obj.baudrate),'CallbackProperties');
            set(obj.jobject, 'PropertyChangeCallback',@obj.callback);
            
            pause(2);
            obj.jobject.open();
            pause(2);
        end
        
        function setSensorToZero(obj)
            obj.jobject.setSensorToZero();
        end
        
        function startCyclicTransmission(obj, timeInMilliSeconds)
            if(ishandle(obj.jobject))
                obj.jobject.startCyclicTransmission(timeInMilliSeconds);
            end
        end

        function result = readForcesAndTorquesBlocking(obj)
            result = obj.jobject.readForcesAndTorquesBlocking();
        end
        
        function close(obj)
            if(ishandle(obj.jobject))
                set(obj.jobject, 'PropertyChangeCallback',{});
                obj.jobject.close();
                obj.jobject.delete();
            end
            obj.callbacks = {};
        end
        
        function delete(obj)
            obj.callbacks = {};
            obj.close();
        end
        
        function addCallback(obj, cb)
            obj.callbacks{end+1} = cb;
        end
        
        function callback(obj, handle, event)
            sensorData = event.getNewValue();%double(typecast(event.getNewValue(),'float'));
            cellfun(@(cb)cb(sensorData),obj.callbacks);
        end
        
    end
    
end

